Last Comment Bug 674083 - Invent & implement teleportation
: Invent & implement teleportation
Status: RESOLVED FIXED
[2042q3][docs-will-have-been-needed]
: dev-doc-complete
Product: mozilla.org Graveyard
Classification: Graveyard
Component: Server Operations: Projects (show other bugs)
: other
: x86_64 Linux
: -- enhancement (vote)
: ---
Assigned To: Shyam Mani [:fox2mike]
: matthew zeier [:mrz]
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-07-25 15:22 PDT by Blair McBride [:Unfocused] (mostly unavailable, needinfo open, reviews not)
Modified: 2015-09-30 02:22 PDT (History)
43 users (show)
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments

Description Blair McBride [:Unfocused] (mostly unavailable, needinfo open, reviews not) 2011-07-25 15:22:48 PDT
Traveling to other parts of the world via a flying metal tube with wings is not only inefficient, its also quite a horrible user experience. Not to mention the huge annual costs to Mozilla.

As an alternative, I'd like to have teleportation invented and implemented under an open standard.

Note that we should be careful about liberally accepting input, as this has proven to not work well in the past (http://youtu.be/F7xoyu08xNE).

Bonus points for having a time travel feature, which could be used to help combat the evil that is timezones.
Comment 1 Dave Townsend [:mossop] 2011-07-25 15:28:35 PDT
(In reply to comment #0)
> Bonus points for having a time travel feature, which could be used to help
> combat the evil that is timezones.

I believe that this problem is easily solved by keeping the traveller in some kind of buffer for as long as the timezone difference between the two locations. Straightforward if you can afford enough hard disks for the job. I recommend a RAID setup though.
Comment 2 Shyam Mani [:fox2mike] 2011-07-25 15:51:04 PDT
SSDs maybe? This is certainly projects.
Comment 3 Shyam Mani [:fox2mike] 2011-07-25 15:52:16 PDT
Need an ack from mrz and cshields, this is going to take up a lot of time and resources.
Comment 4 Corey Shields [:cshields] 2011-07-25 15:54:17 PDT
(In reply to comment #3)
> Need an ack from mrz and cshields, this is going to take up a lot of time
> and resources.

+1 here, I could make use of this as well..   Just be sure it is implemented with Puppet and that it is fully documented in the wiki so that oncall can properly troubleshoot teleportation outages.
Comment 5 Richard Newman [:rnewman] 2011-07-25 15:55:57 PDT
This would make new network setups much easier, I think.
Comment 6 Amy Rich [:arr] [:arich] 2011-07-25 15:59:12 PDT
Can I get an ETA on this?
Comment 7 Corey Shields [:cshields] 2011-07-25 16:00:01 PDT
(In reply to comment #6)
> Can I get an ETA on this?

Marked the whiteboard, we'll make this a Q2 2042 goal..
Comment 8 Ben Kero [:bkero] 2011-07-25 16:02:29 PDT
Have we thought about the security and safety risks of this?  http://www.youtube.com/watch?v=m6vYKJerstg is a risk I don't want any of our developers to fall victim to.
Comment 9 Jake Maul [:jakem] 2011-07-25 16:58:11 PDT
I don't know about the timezone issue, but I think we'll need a good bit of extra bandwidth to make this happen. The complete humane genome is around 800MB compressed, and this clearly does not contain memories or experiences or even a person's unique physiology.

Given that the data to be transported (one human being) comes from only one source and we only need one full copy at a time, P2P protocols like bittorrent are unlikely to be of significant assistance. Besides, the use of a P2P system could be construed as a security risk anyway.
Comment 10 Corey Shields [:cshields] 2011-07-25 17:18:19 PDT
Ravi is on to something with the colo-trip.  Can we use the teleportation to migrate servers out of sjc1 and into another data center?  Or is this for humans only?
Comment 11 Shyam Mani [:fox2mike] 2011-07-25 17:18:45 PDT
Ravi - This should be in SCL3. Also, Linux.
Comment 12 Zandr Milewski [:zandr] 2011-07-25 17:39:28 PDT
"...it has never been /successfully/ tested..."
Comment 13 Richard Soderberg [:atoll] 2011-07-25 18:39:58 PDT
I propose a new protocol, Derivative of Alpha-Fox Teleport (in other words, DAFT) modeled after the existing Alpha-Fox command language for manipulating such things.

per http://www.alpha-fox.com/resources/ats/manual/#s4 -

tp set otherdest|<0/1>	Allows you to set whether you want people to be able to teleport to arbritrary destinations with your teleporter. Defaulted to 0.
tp set offset|<offset>	For transport rings, allows you to set the offset the rings should rez at. Useful for making rings drop from the ceiling.

etc.
Comment 14 Ravi Pina [:ravi] 2011-07-25 18:48:16 PDT
Added SCL3 to the list...

I like where you're going with the idea of using teleportation for the server move.
Comment 15 Sean Martell 2011-07-25 19:10:06 PDT
Please open a separate visual design bug when it comes time for a logo for this project. I'll start in on some sketches in the meantime.

Thanks!
Comment 16 Eric Shepherd [:sheppy] 2011-07-25 19:58:56 PDT
Need to be sure to use a very precise checksum on the data stream. I'd hate to come out the other end with extra parts.
Comment 17 Brett Gaylor [:brett] 2011-07-25 20:12:16 PDT
Please ensure Foundation employees have this enabled in their LDAP. Sick of seeing you guys teleport to Vegas all the time.
Comment 18 Justin Dolske [:Dolske] 2011-07-25 20:56:55 PDT
Pretty sure the Enterprise working group will take care of this. Dr. Emory Erickson would know more.
Comment 19 Corey Shields [:cshields] 2011-07-25 22:35:16 PDT
(In reply to comment #16)
> Need to be sure to use a very precise checksum on the data stream. I'd hate
> to come out the other end with extra parts.

hrmm.. Might be a good idea to use forward error correction in the stream.
Comment 20 Corey Shields [:cshields] 2011-07-25 22:45:56 PDT
(In reply to comment #14)
> I like where you're going with the idea of using teleportation for the
> server move.

Why stop with people and servers?

Once teleportation v2 rolls out through the rapid release cycle, let's add the ability to teleport ethernet packets themselves.  We will save money and get better speeds on our cross-datacenter p2p links.
Comment 21 Ravi Pina [:ravi] 2011-07-25 23:13:40 PDT
Will this scale?  Do we need to front this with a LB?  Is this on Zeus's road map to support?
Comment 22 Brian King [:kinger] 2011-07-25 23:54:00 PDT
(In reply to comment #16)
> Need to be sure to use a very precise checksum on the data stream. I'd hate
> to come out the other end with extra parts.

Extra parts would be cool, like superpowers. I'd be more worried about less parts.
Comment 23 Deb Richardson [:dria] (plz NEEDINFO) 2011-07-26 00:44:13 PDT
Fewer actual parts would be an issue, but if we could implement an automated weight-loss algorithm, I'd be ok with that. +1
Comment 24 Rob Campbell [:rc] (:robcee) 2011-07-26 11:48:15 PDT
I think this feature should be available on mobile so we can use it anywhere.

Also, I'd really like to see some unittests.
Comment 25 Andrew Drake [:adrake] 2011-07-26 13:06:57 PDT
Is this going to require any new Just-in-Time compilation infrastructure?
Comment 26 Jo Hermans 2011-07-26 13:12:30 PDT
You're confusing this with TimeTravel :-)
Comment 27 Les Orchard [:lorchard] 2011-08-04 09:35:00 PDT
Man, we really could have used this for bug 448604
Comment 28 neil@parkwaycc.co.uk 2011-08-04 09:41:23 PDT
(In reply to comment #20)
> Why stop with people and servers?
> 
> Once teleportation v2 rolls out through the rapid release cycle, let's add
> the ability to teleport ethernet packets themselves.  We will save money and
> get better speeds on our cross-datacenter p2p links.

Only once you get time travel going. Then you'll be able to capture packets on an incoming server, send it back in time to when you started the packet capture, and replay the packets at the destination.
Comment 29 Brandon Savage [:brandon] 2011-08-04 10:42:53 PDT
I, like so many others, face time crunches and I believe that this issue ought to be raised to a blocker. Any update on who is going to ultimately be responsible for implementation here?
Comment 30 Richard Newman [:rnewman] 2011-08-04 10:52:02 PDT
(In reply to comment #29)
> Any update on who is going to ultimately be
> responsible for implementation here?

Assuming the inclusion of the proposed time travel feature: before we can assign this bug to someone, we need to extend Bugzilla to support referencing accounts that don't yet exist, or belong to people who might not have been born.

It's very corp-centric to assume that the implementation will be performed by someone contemporary with the current organization.

As always, this comes down to a tools issue.
Comment 31 Eric Shepherd [:sheppy] 2011-08-04 10:54:07 PDT
From a documentation standpoint, I have concerns about the need to invent new grammatical tenses (such as the past future potential predeterminate). We may need to file dependency bugs against the English language.
Comment 32 Jake Maul [:jakem] 2011-08-04 14:41:38 PDT
(In reply to comment #31)
> From a documentation standpoint, I have concerns about the need to invent
> new grammatical tenses (such as the past future potential predeterminate).
> We may need to file dependency bugs against the English language.

As described in Dr. Dan Streetmentioner's "Time Traveler's Handbook of 1001 Tense Formations", the major complication with time travel is indeed grammar. Fortunately for us, this book is already written. Or rather, will be, in the future. We'll simply need to pick up a copy after traveling forward to that time. This will be handy for later discussions about the all-hands lunch we will have had at Milliways, the Restaurant at the End of the Universe.
Comment 33 Sebastian H. [:aryx][:archaeopteryx] 2011-08-04 15:29:24 PDT
Two objects cannot share the same space, so requesting needs-tree-logging? in the destination zones.
Comment 34 Richard Soderberg [:atoll] 2011-08-26 15:28:45 PDT
This has been completed successfully. Unfortunately due to the sensitive nature of the construction required, details must remain private. Said details are available on request to those with timesec bugzilla group privileges, otherwise will be made public in 2042q4 once the final implementation is released.
Comment 35 Shawn Gong 2011-09-04 15:08:32 PDT
AGREED!!

Note You need to log in before you can comment on or make changes to this bug.